@echo off
rem
rem Batch per la generazione automatica di codice HTML per l'inserimento
rem automatico di files .JPG e loro icone _ICO.JPG
rem Versione 1.0 by Gianluca Pisano 08/07/1999
rem
rem Il codice HTML sar contenuto in un file files.txt
rem

rem Nota: all'interno del HTMLcode.txt  possibile inserire variabili
rem di ambiente usate poi all'interno del programma, nel formato
rem             service: var_name=var_cont
rem per esempio la linea
rem             service:fileSEARCH=*.jpg
rem indica allo shell che deve sostituire ogni ricorrenza di %fileSCAN%
rem all'interno del file con il nome di un file JPG trovato, e ripetere
rem il codice HTML dentro il file una volta per ogni diverso file JPG trovato
rem

echo Checking command.com used is 4dos...
if not "%@eval[2 + 2]%" == "4" set err=1
if not "%@eval[2 + 2]%" == "4" goto errore

setlocal

rem Configurazione default
set servizio=service:
set HTMLcode=HTMLcode.txt

rem Configurazione default modificabile all'interno di HTMLcode
set fileSEARCH=*.jpg
set HTMLcode=HTMLcode.txt
set HTMLhead=HTMLhead.txt
set HTMLgen=files.txt

echo Checking configuration into %HTMLcode...
set num_HTML_file=%@fileopen[%HTMLcode,read,t]
iff "%num_HTML_file" == "-1" then
  set err=2
  goto errore
endiff

gosub sub_cfg_search

echo Starting work...

set num_write_file=%@fileopen[%HTMLgen,write,t]
iff "%num_write_file" == "-1" then
  set err=3
  goto errore
endiff

set num_head_file=%@fileopen[%HTMLhead,read,t]
iff "%num_head_file" == "-1" then
  echo No head HTML found... skip it...
  goto code_HTML
endiff

gosub sub_insert_HTML_header

set err_out=%@fileclose[%num_head_file]
iff "%err_out" == "-1" then
  set err=5
  goto errore
endiff

:code_HTML
echo Starting working with %HTMLcode (%@lines[%HTMLcode] lines)...

for %fileSCAN in (%fileSEARCH) do gosub sub_insert_HTML_code

set err_out=%@fileclose[%num_HTML_file]
iff "%err_out" == "-1" then
  set err=5
  goto errore
endiff

set err_out=%@fileclose[%num_write_file]
iff "%err_out" == "-1" then
  err=6
  goto errore
endiff

:fine
endlocal
quit


:sub_cfg_search
echo Searching %servizio lines into %HTMLcode file...

set err_out=%@fileseekl[%num_HTML_file,0]

setdos /x-56
set txt=%@fileread[%num_HTML_file]
do
  iff "%@upper[%@left[%@len[%servizio],%txt]]" == "%@upper[%servizio]" then

    rem preparare prima: char_searched, str_search
    rem generato found e search_result
    set char_searched==
    set str_search=%txt
    gosub search_char
    iff "%found" == "SI" then
      set primo=%@instr[%@inc[%@len[%servizio]],%@eval[%search_result - %@len[%servizio] -1],%str_search]
      set secondo=%@right[%@eval[%@len[%str_search] - %search_result - 1],%str_search]
      set %primo=%secondo
      rem echo %primo=%secondo
    endiff

  endiff
  set txt=%@fileread[%num_HTML_file]
  if "%txt" == "**EOF**" leave
enddo
setdos /x+56
return

:search_char
rem Cerca 1 carattere all'interno di una stringa
rem preparare prima: char_searched, str_search
rem generato found e search_result
set search_result=-1
set found=NO
rem do forever
do while %search_result le %@len[str_search] .and. "%found" == "NO"
  set search_result=%@inc[%search_result]
  if "%@upper[%@instr[%search_result%,1,%str_search%]]" == "%@upper[%char_searched]" set found=SI
enddo
return


:sub_insert_HTML_header

echo Writing header from file %HTMLhead to %HTMLgen...
set num_line=0

setdos /x-56 
rem 5 x !
rem 6 x <>
set txt=%@fileread[%num_head_file]
do
  set num_line=%@inc[%num_line]
  rem echo Text line processed (%@format[2,%num_line]): %txt
  set err_out=%@filewrite[%num_write_file,%txt]
  iff "%err_out" == "-1" then
    set err=4
    goto errore
  endiff
  iff not "%@dec[%@dec[%err_out]]" == "%@len[%txt]" then
    rem echo %txt -) %err_out %@len[%txt] -) %@inc[%@inc[%err_out]] %@len[%txt]
    set err=9
    goto errore
  endiff
  set txt=%@fileread[%num_head_file]
  if "%txt" == "**EOF**" leave
enddo
setdos /x+56

echo %num_line lines used (from heade file %HTMLhead).

return

:sub_insert_HTML_code
rem *** Inserisce nel file HTML di output una volta il file HTMLcode
set err_out=%@fileseekl[%num_HTML_file,0]

setdos /x-56
set txt=%@fileread[%num_HTML_file]
do
  rem echo Text line processed: %txt
  iff not "%@upper[%@left[%@len[%servizio],%txt]]" == "%@upper[%servizio]" then
    rem Scrivo solo se la linea non comincia con 'service:'
    set err_out=%@filewrite[%num_write_file,%txt]
    iff "%err_out" == "-1" then
      set err=4
      goto errore
    endiff
    iff not "%@dec[%@dec[%err_out]]" == "%@len[%txt]" then
      set err=9
      goto errore
    endiff
  endiff
  set txt=%@fileread[%num_HTML_file]
  if "%txt" == "**EOF**" leave
enddo
setdos /x+56
return

:errore
switch %err
  case 1
    echo 4dos required but not available...
  case 2
    set err_canc=%@fileclose[%num_write_file]
    echo HTML input code (%HTMLcode) not found...
  case 3
    set err_canc=%@fileclose[%num_HTML_file]
    echo Can't write on %HTMLgen ...
  case 4
    set err_canc=%@fileclose[%num_write_file]
    set err_canc=%@fileclose[%num_head_file]
    set err_canc=%@fileclose[%num_HTML_file]
    echo Unexpected error writing on %HTMLgen...
  case 5
    set err_canc=%@fileclose[%num_write_file]
    set err_canc=%@fileclose[%num_HTML_file]
    echo Error closing input file (%HTMLcode)...
  case 6
    echo Error closing output file (%HTMLgen)...
  case 7
    set err_canc=%@fileclose[%num_HTML_file]
    echo Unexpected error writing header tag HTML on %HTMLgen...
  case 8
    set err_canc=%@fileclose[%num_write_file]
    set err_canc=%@fileclose[%num_HTML_file]
    echo HTML header input code (%HTMLhead) not found...
  case 9
    set err_canc=%@fileclose[%num_write_file]
    set err_canc=%@fileclose[%num_head_file]
    set err_canc=%@fileclose[%num_HTML_file]
    echo Error writing %HTMLgen: number of chars readed and writen don't match...
  default
    set err_canc=%@fileclose[%num_HTML_file]
    echo Errore indefinito!!!
endswitch

goto fine

rem :leva_jpg_finale
rem set ris=@left["%@len["%str"],"str"]
rem return

